<?php

namespace Qls\ServicePoints\Struct;

use Shopware\Core\Framework\Struct\Struct;

class ServicePoint extends Struct
{
    public const CODE = 'service_point_code';
    public const NAME = 'service_point_name';
    public const STREET_AND_NUMBER = 'service_point_street_and_number';
    public const POSTAL_CODE_AND_CITY = 'service_point_postal_code_and_city';
    public const COUNTRY = 'service_point_country';

    public string $code;

    public string $name;

    public string $streetAndNumber;

    public string $postalCodeAndCity;

    public string $country;

    public function __construct(string $code, string $name, string $streetAndNumber, string $postalCodeAndCity, string $country)
    {
        $this->code = $code;
        $this->name = $name;
        $this->streetAndNumber = $streetAndNumber;
        $this->postalCodeAndCity = $postalCodeAndCity;
        $this->country = $country;
    }

    public static function fromArray(array $data): self
    {
        return new self(
            $data[self::CODE],
            $data[self::NAME],
            $data[self::STREET_AND_NUMBER],
            $data[self::POSTAL_CODE_AND_CITY],
            $data[self::COUNTRY],
        );
    }

    public function toArray(): array
    {
        return [
            self::CODE => $this->code,
            self::NAME => $this->name,
            self::STREET_AND_NUMBER => $this->streetAndNumber,
            self::POSTAL_CODE_AND_CITY => $this->postalCodeAndCity,
            self::COUNTRY => $this->country,
        ];
    }
}
