<?php

declare(strict_types=1);

namespace Qls\ServicePoints\Test\Service;

use PHPUnit\Framework\TestCase;
use Qls\ServicePoints\Service\OrderAddressService;
use Qls\ServicePoints\Struct\ServicePoint;
use Shopware\Core\Checkout\Order\Aggregate\OrderAddress\OrderAddressEntity;

class OrderAddressServiceTest extends TestCase
{
    private OrderAddressService $orderAddressService;

    public function setUp(): void
    {
        $this->orderAddressService = new OrderAddressService();
    }

    public function testItGetsServicePointFromCustomFields(): void
    {
        $orderAddressEntity = new OrderAddressEntity();
        $orderAddressEntity->setCustomFields([
            'service_point_code' => '::code::',
            'service_point_name' => '::name::',
            'service_point_street_and_number' => '::streetAndNumber::',
            'service_point_postal_code_and_city' => '::postalCodeAndCity::',
            'service_point_country' => '::country::'
        ]);

        $servicePoint = $this->orderAddressService->getServicePointFromCustomFields($orderAddressEntity);

        $this->assertEquals($servicePoint, new ServicePoint(
            '::code::',
            '::name::',
            '::streetAndNumber::',
            '::postalCodeAndCity::',
            '::country::'
        ));
    }
}
